"use strict";
/**
 * Event Handlers.
 *
 * Optimizing compilers should inline all this functions and completely remove unused code.
 */
Object.defineProperty(exports, "__esModule", { value: true });
const native_event_source_1 = require("./native_event_source");
/* tslint:disable:max-line-length */
exports.EVENT_SOURCE_ABORT = native_event_source_1.createNativeEventSource(1 /* Capture */, "abort");
exports.EVENT_SOURCE_ACTIVATE = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "activate");
exports.EVENT_SOURCE_ARIA_REQUEST = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "ariarequest");
exports.EVENT_SOURCE_BEFORE_ACTIVATE = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "beforeactivate");
exports.EVENT_SOURCE_BEFORE_COPY = native_event_source_1.createNativeEventSource(1 /* Capture */, "beforecopy");
exports.EVENT_SOURCE_BEFORE_CUT = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "beforecut");
exports.EVENT_SOURCE_BEFORE_DEACTIVATE = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "beforedeactivate");
exports.EVENT_SOURCE_BEFORE_PASTE = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "beforepaste");
exports.EVENT_SOURCE_BLUR = native_event_source_1.createNativeEventSource(1 /* Capture */, "blur");
exports.EVENT_SOURCE_CAN_PLAY = native_event_source_1.createNativeEventSource(1 /* Capture */, "canplay");
exports.EVENT_SOURCE_CAN_PLAYTHROUGH = native_event_source_1.createNativeEventSource(1 /* Capture */, "canplaythrough");
exports.EVENT_SOURCE_CHANGE = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "change");
exports.EVENT_SOURCE_CLICK = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "click");
exports.EVENT_SOURCE_CONTEXT_MENU = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "contextmenu");
exports.EVENT_SOURCE_COPY = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "copy");
exports.EVENT_SOURCE_CUE_CHANGE = native_event_source_1.createNativeEventSource(1 /* Capture */, "cuechange");
exports.EVENT_SOURCE_CUT = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "cut");
exports.EVENT_SOURCE_DOUBLE_CLICK = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "dblclick");
exports.EVENT_SOURCE_DEACTIVATE = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "deactivate");
exports.EVENT_SOURCE_DRAG = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "drag");
exports.EVENT_SOURCE_DRAG_END = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "dragend");
exports.EVENT_SOURCE_DRAG_ENTER = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "dragenter");
exports.EVENT_SOURCE_DRAG_LEAVE = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "dragleave");
exports.EVENT_SOURCE_DRAG_OVER = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "dragover");
exports.EVENT_SOURCE_DRAG_START = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "dragstart");
exports.EVENT_SOURCE_DROP = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "drop");
exports.EVENT_SOURCE_DURATION_CHANGE = native_event_source_1.createNativeEventSource(1 /* Capture */, "durationchange");
exports.EVENT_SOURCE_EMPTIED = native_event_source_1.createNativeEventSource(1 /* Capture */, "emptied");
exports.EVENT_SOURCE_ENCRYPTED = native_event_source_1.createNativeEventSource(1 /* Capture */, "encrypted");
exports.EVENT_SOURCE_ENDED = native_event_source_1.createNativeEventSource(1 /* Capture */, "ended");
exports.EVENT_SOURCE_ERROR = native_event_source_1.createNativeEventSource(1 /* Capture */, "error");
exports.EVENT_SOURCE_FOCUS = native_event_source_1.createNativeEventSource(1 /* Capture */, "focus");
exports.EVENT_SOURCE_GOT_POINTER_CAPTURE = native_event_source_1.createNativeEventSource(1 /* Capture */, "gotpointercapture");
exports.EVENT_SOURCE_INPUT = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "input");
exports.EVENT_SOURCE_INVALID = native_event_source_1.createNativeEventSource(1 /* Capture */, "invalid");
exports.EVENT_SOURCE_KEY_DOWN = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "keydown");
exports.EVENT_SOURCE_KEY_PRESS = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "keypress");
exports.EVENT_SOURCE_KEY_UP = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "keyup");
exports.EVENT_SOURCE_LOAD = native_event_source_1.createNativeEventSource(1 /* Capture */, "load");
exports.EVENT_SOURCE_LOADED_DATA = native_event_source_1.createNativeEventSource(1 /* Capture */, "loadeddata");
exports.EVENT_SOURCE_LOADED_METADATA = native_event_source_1.createNativeEventSource(1 /* Capture */, "loadedmetadata");
exports.EVENT_SOURCE_LOAD_START = native_event_source_1.createNativeEventSource(1 /* Capture */, "loadstart");
exports.EVENT_SOURCE_LOST_POINTER_CAPTURE = native_event_source_1.createNativeEventSource(1 /* Capture */, "lostpointercapture");
exports.EVENT_SOURCE_MOUSE_DOWN = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "mousedown");
exports.EVENT_SOURCE_MOUSE_ENTER = native_event_source_1.createNativeEventSource(1 /* Capture */, "mouseenter");
exports.EVENT_SOURCE_MOUSE_LEAVE = native_event_source_1.createNativeEventSource(1 /* Capture */, "mouseleave");
exports.EVENT_SOURCE_MOUSE_MOVE = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "mousemove");
exports.EVENT_SOURCE_MOUSE_OUT = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "mouseout");
exports.EVENT_SOURCE_MOUSE_OVER = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "mouseover");
exports.EVENT_SOURCE_MOUSE_UP = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "mouseup");
exports.EVENT_SOURCE_PASTE = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "paste");
exports.EVENT_SOURCE_PAUSE = native_event_source_1.createNativeEventSource(1 /* Capture */, "pause");
exports.EVENT_SOURCE_PLAY = native_event_source_1.createNativeEventSource(1 /* Capture */, "play");
exports.EVENT_SOURCE_PLAYING = native_event_source_1.createNativeEventSource(1 /* Capture */, "playing");
exports.EVENT_SOURCE_POINTER_CANCEL = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "pointercancel");
exports.EVENT_SOURCE_POINTER_DOWN = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "pointerdown");
exports.EVENT_SOURCE_POINTER_ENTER = native_event_source_1.createNativeEventSource(1 /* Capture */, "pointerenter");
exports.EVENT_SOURCE_POINTER_LEAVE = native_event_source_1.createNativeEventSource(1 /* Capture */, "pointerleave");
exports.EVENT_SOURCE_POINTER_MOVE = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "pointermove");
exports.EVENT_SOURCE_POINTER_OUT = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "pointerout");
exports.EVENT_SOURCE_POINTER_OVER = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "pointerover");
exports.EVENT_SOURCE_POINTER_UP = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "pointerup");
exports.EVENT_SOURCE_PROGRESS = native_event_source_1.createNativeEventSource(1 /* Capture */, "progress");
exports.EVENT_SOURCE_RATE_CHANGE = native_event_source_1.createNativeEventSource(1 /* Capture */, "ratechange");
exports.EVENT_SOURCE_RESET = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "reset");
exports.EVENT_SOURCE_SCROLL = native_event_source_1.createNativeEventSource(1 /* Capture */, "scroll");
exports.EVENT_SOURCE_SEEKED = native_event_source_1.createNativeEventSource(1 /* Capture */, "seeked");
exports.EVENT_SOURCE_SEEKING = native_event_source_1.createNativeEventSource(1 /* Capture */, "seeking");
exports.EVENT_SOURCE_SELECT = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "select");
exports.EVENT_SOURCE_SELECT_START = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "selectstart");
exports.EVENT_SOURCE_STALLED = native_event_source_1.createNativeEventSource(1 /* Capture */, "stalled");
exports.EVENT_SOURCE_SUBMIT = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "submit");
exports.EVENT_SOURCE_SUSPEND = native_event_source_1.createNativeEventSource(1 /* Capture */, "suspend");
exports.EVENT_SOURCE_TIME_UPDATE = native_event_source_1.createNativeEventSource(1 /* Capture */, "timeupdate");
exports.EVENT_SOURCE_TOUCH_CANCEL = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "touchcancel");
exports.EVENT_SOURCE_TOUCH_END = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */ | 2 /* Passive */, "touchend");
exports.EVENT_SOURCE_TOUCH_MOVE = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */ | 2 /* Passive */, "touchmove");
exports.EVENT_SOURCE_TOUCH_START = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */ | 2 /* Passive */, "touchstart");
exports.EVENT_SOURCE_UNLOAD = native_event_source_1.createNativeEventSource(1 /* Capture */, "unload");
exports.EVENT_SOURCE_VOLUME_CHANGE = native_event_source_1.createNativeEventSource(1 /* Capture */, "volumechange");
exports.EVENT_SOURCE_WAITING = native_event_source_1.createNativeEventSource(1 /* Capture */, "waiting");
exports.EVENT_SOURCE_WHEEL = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */ | 2 /* Passive */, "wheel");
exports.EVENT_SOURCE_ACTIVE_TOUCH_END = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "touchend");
exports.EVENT_SOURCE_ACTIVE_TOUCH_MOVE = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "touchmove");
exports.EVENT_SOURCE_ACTIVE_TOUCH_START = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "touchstart");
exports.EVENT_SOURCE_ACTIVE_WHEEL = native_event_source_1.createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "wheel");
/**
 * Helper function that creates event handlers.
 *
 * @param src - Event source
 * @param handler - Event Handler function
 * @param capture - Capture mode
 * @returns EventHandler instance
 */
function createEventHandler(src, handler, capture) {
    return {
        src,
        flags: capture === true ? 1 /* Capture */ : 2 /* Bubble */,
        handler,
        listeners: 0,
        props: null,
        state: null,
    };
}
exports.createEventHandler = createEventHandler;
function onAbort(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_ABORT.src, handler, capture);
}
exports.onAbort = onAbort;
function onActivate(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_ACTIVATE.src, handler, capture);
}
exports.onActivate = onActivate;
function onAriaRequest(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_ARIA_REQUEST.src, handler, capture);
}
exports.onAriaRequest = onAriaRequest;
function onBeforeActivate(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_BEFORE_ACTIVATE.src, handler, capture);
}
exports.onBeforeActivate = onBeforeActivate;
function onBeforeCopy(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_BEFORE_COPY.src, handler, capture);
}
exports.onBeforeCopy = onBeforeCopy;
function onBeforeCut(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_BEFORE_CUT.src, handler, capture);
}
exports.onBeforeCut = onBeforeCut;
function onBeforeDeactivate(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_BEFORE_DEACTIVATE.src, handler, capture);
}
exports.onBeforeDeactivate = onBeforeDeactivate;
function onBeforePaste(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_BEFORE_PASTE.src, handler, capture);
}
exports.onBeforePaste = onBeforePaste;
function onBlur(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_BLUR.src, handler, capture);
}
exports.onBlur = onBlur;
function onCanPlay(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_CAN_PLAY.src, handler, capture);
}
exports.onCanPlay = onCanPlay;
function onCanPlaythrough(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_CAN_PLAYTHROUGH.src, handler, capture);
}
exports.onCanPlaythrough = onCanPlaythrough;
function onChange(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_CHANGE.src, handler, capture);
}
exports.onChange = onChange;
function onClick(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_CLICK.src, handler, capture);
}
exports.onClick = onClick;
function onContextMenu(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_CONTEXT_MENU.src, handler, capture);
}
exports.onContextMenu = onContextMenu;
function onCopy(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_COPY.src, handler, capture);
}
exports.onCopy = onCopy;
function onCueChange(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_CUE_CHANGE.src, handler, capture);
}
exports.onCueChange = onCueChange;
function onCut(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_CUT.src, handler, capture);
}
exports.onCut = onCut;
function onDoubleClick(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_DOUBLE_CLICK.src, handler, capture);
}
exports.onDoubleClick = onDoubleClick;
function onDeactivate(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_DEACTIVATE.src, handler, capture);
}
exports.onDeactivate = onDeactivate;
function onDrag(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_DRAG.src, handler, capture);
}
exports.onDrag = onDrag;
function onDragEnd(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_DRAG_END.src, handler, capture);
}
exports.onDragEnd = onDragEnd;
function onDragEnter(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_DRAG_ENTER.src, handler, capture);
}
exports.onDragEnter = onDragEnter;
function onDragLeave(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_DRAG_LEAVE.src, handler, capture);
}
exports.onDragLeave = onDragLeave;
function onDragOver(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_DRAG_OVER.src, handler, capture);
}
exports.onDragOver = onDragOver;
function onDragStart(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_DRAG_START.src, handler, capture);
}
exports.onDragStart = onDragStart;
function onDrop(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_DROP.src, handler, capture);
}
exports.onDrop = onDrop;
function onDurationChange(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_DURATION_CHANGE.src, handler, capture);
}
exports.onDurationChange = onDurationChange;
function onEmptied(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_EMPTIED.src, handler, capture);
}
exports.onEmptied = onEmptied;
function onEncrypted(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_ENCRYPTED.src, handler, capture);
}
exports.onEncrypted = onEncrypted;
function onEnded(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_ENDED.src, handler, capture);
}
exports.onEnded = onEnded;
function onError(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_ERROR.src, handler, capture);
}
exports.onError = onError;
function onFocus(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_FOCUS.src, handler, capture);
}
exports.onFocus = onFocus;
function onGotPointerCapture(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_GOT_POINTER_CAPTURE.src, handler, capture);
}
exports.onGotPointerCapture = onGotPointerCapture;
function onInput(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_INPUT.src, handler, capture);
}
exports.onInput = onInput;
function onInvalid(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_INVALID.src, handler, capture);
}
exports.onInvalid = onInvalid;
function onKeyDown(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_KEY_DOWN.src, handler, capture);
}
exports.onKeyDown = onKeyDown;
function onKeyPress(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_KEY_PRESS.src, handler, capture);
}
exports.onKeyPress = onKeyPress;
function onKeyUp(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_KEY_UP.src, handler, capture);
}
exports.onKeyUp = onKeyUp;
function onLoad(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_LOAD.src, handler, capture);
}
exports.onLoad = onLoad;
function onLoadedData(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_LOADED_DATA.src, handler, capture);
}
exports.onLoadedData = onLoadedData;
function onLoadedMetadata(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_LOADED_METADATA.src, handler, capture);
}
exports.onLoadedMetadata = onLoadedMetadata;
function onLoadStart(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_LOAD_START.src, handler, capture);
}
exports.onLoadStart = onLoadStart;
function onLostPointerCapture(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_LOST_POINTER_CAPTURE.src, handler, capture);
}
exports.onLostPointerCapture = onLostPointerCapture;
function onMouseDown(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_MOUSE_DOWN.src, handler, capture);
}
exports.onMouseDown = onMouseDown;
function onMouseEnter(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_MOUSE_ENTER.src, handler, capture);
}
exports.onMouseEnter = onMouseEnter;
function onMouseLeave(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_MOUSE_LEAVE.src, handler, capture);
}
exports.onMouseLeave = onMouseLeave;
function onMouseMove(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_MOUSE_MOVE.src, handler, capture);
}
exports.onMouseMove = onMouseMove;
function onMouseOut(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_MOUSE_OUT.src, handler, capture);
}
exports.onMouseOut = onMouseOut;
function onMouseOver(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_MOUSE_OVER.src, handler, capture);
}
exports.onMouseOver = onMouseOver;
function onMouseUp(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_MOUSE_UP.src, handler, capture);
}
exports.onMouseUp = onMouseUp;
function onPaste(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_PASTE.src, handler, capture);
}
exports.onPaste = onPaste;
function onPause(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_PAUSE.src, handler, capture);
}
exports.onPause = onPause;
function onPlay(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_PLAY.src, handler, capture);
}
exports.onPlay = onPlay;
function onPlaying(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_PLAYING.src, handler, capture);
}
exports.onPlaying = onPlaying;
function onPointerCancel(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_POINTER_CANCEL.src, handler, capture);
}
exports.onPointerCancel = onPointerCancel;
function onPointerDown(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_POINTER_DOWN.src, handler, capture);
}
exports.onPointerDown = onPointerDown;
function onPointerEnter(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_POINTER_ENTER.src, handler, capture);
}
exports.onPointerEnter = onPointerEnter;
function onPointerLeave(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_POINTER_LEAVE.src, handler, capture);
}
exports.onPointerLeave = onPointerLeave;
function onPointerMove(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_POINTER_MOVE.src, handler, capture);
}
exports.onPointerMove = onPointerMove;
function onPointerOut(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_POINTER_OUT.src, handler, capture);
}
exports.onPointerOut = onPointerOut;
function onPointerOver(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_POINTER_OVER.src, handler, capture);
}
exports.onPointerOver = onPointerOver;
function onPointerUp(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_POINTER_UP.src, handler, capture);
}
exports.onPointerUp = onPointerUp;
function onProgress(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_PROGRESS.src, handler, capture);
}
exports.onProgress = onProgress;
function onRateChange(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_RATE_CHANGE.src, handler, capture);
}
exports.onRateChange = onRateChange;
function onReset(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_RESET.src, handler, capture);
}
exports.onReset = onReset;
function onScroll(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_SCROLL.src, handler, capture);
}
exports.onScroll = onScroll;
function onSeeked(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_SEEKED.src, handler, capture);
}
exports.onSeeked = onSeeked;
function onSeeking(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_SEEKING.src, handler, capture);
}
exports.onSeeking = onSeeking;
function onSelect(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_SELECT.src, handler, capture);
}
exports.onSelect = onSelect;
function onSelectStart(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_SELECT_START.src, handler, capture);
}
exports.onSelectStart = onSelectStart;
function onStalled(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_STALLED.src, handler, capture);
}
exports.onStalled = onStalled;
function onSubmit(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_SUBMIT.src, handler, capture);
}
exports.onSubmit = onSubmit;
function onSuspend(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_SUSPEND.src, handler, capture);
}
exports.onSuspend = onSuspend;
function onTimeUpdate(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_TIME_UPDATE.src, handler, capture);
}
exports.onTimeUpdate = onTimeUpdate;
function onTouchCancel(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_TOUCH_CANCEL.src, handler, capture);
}
exports.onTouchCancel = onTouchCancel;
function onTouchEnd(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_TOUCH_END.src, handler, capture);
}
exports.onTouchEnd = onTouchEnd;
function onTouchMove(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_TOUCH_MOVE.src, handler, capture);
}
exports.onTouchMove = onTouchMove;
function onTouchStart(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_TOUCH_START.src, handler, capture);
}
exports.onTouchStart = onTouchStart;
function onUnload(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_UNLOAD.src, handler, capture);
}
exports.onUnload = onUnload;
function onVolumeChange(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_VOLUME_CHANGE.src, handler, capture);
}
exports.onVolumeChange = onVolumeChange;
function onWaiting(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_WAITING.src, handler, capture);
}
exports.onWaiting = onWaiting;
function onWheel(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_WHEEL.src, handler, capture);
}
exports.onWheel = onWheel;
function onActiveTouchEnd(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_ACTIVE_TOUCH_END.src, handler, capture);
}
exports.onActiveTouchEnd = onActiveTouchEnd;
function onActiveTouchMove(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_ACTIVE_TOUCH_MOVE.src, handler, capture);
}
exports.onActiveTouchMove = onActiveTouchMove;
function onActiveTouchStart(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_ACTIVE_TOUCH_START.src, handler, capture);
}
exports.onActiveTouchStart = onActiveTouchStart;
function onActiveWheel(handler, capture = false) {
    return createEventHandler(exports.EVENT_SOURCE_ACTIVE_WHEEL.src, handler, capture);
}
exports.onActiveWheel = onActiveWheel;
/* tslint:enable:max-line-length */
//# sourceMappingURL=events.js.map