import { EventHandler } from "./event_handler";
/**
 * syncEvents syncs event handlers and invokes EventSource callbacks when event handler is attached or detached.
 *
 * @param a Old event handlers.
 * @param b New event handlers.
 */
export declare function syncEvents(a: Array<EventHandler | null> | EventHandler | null, b: Array<EventHandler | null> | EventHandler | null): void;
/**
 * attachEvents attaches event handlers and invokes EventSource callbacks.
 *
 * @param events Event handlers.
 */
export declare function attachEvents(events: Array<EventHandler | null> | EventHandler): void;
/**
 * detachEvents detaches events handles and invokes EventSource callbacks.
 *
 * @param events Event handlers.
 */
export declare function detachEvents(events: Array<EventHandler | null> | EventHandler): void;
