import { EventHandler } from "./event_handler";
import { DispatchTarget } from "./dispatch";
/**
 * accumulateDispatchTargetsFromElement accumulates matching Event Handlers in `result` array from the `target` Element.
 *
 * @param result Accumulated Dispatch Targets.
 * @param target Target Element.
 * @param match Matching function.
 */
export declare function accumulateDispatchTargetsFromElement(result: DispatchTarget[], target: Element, match: (h: EventHandler) => boolean): void;
/**
 * accumulateDispatchTargets traverses the DOM tree from the `target` Element to the document top and accumulates
 * matching Event Handlers in `result` array.
 *
 * @param result Accumulated Dispatch Targets.
 * @param target Target DOM Element.
 * @param match Matching function.
 */
export declare function accumulateDispatchTargets(result: DispatchTarget[], target: Element | null, match: (h: EventHandler) => boolean): void;
