(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("iviCore"));
	else if(typeof define === 'function' && define.amd)
		define(["iviCore"], factory);
	else if(typeof exports === 'object')
		exports["Events"] = factory(require("iviCore"));
	else
		root["Events"] = factory(root["iviCore"]);
})(window, function(__WEBPACK_EXTERNAL_MODULE__0__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 1);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE__0__;

/***/ }),
/* 1 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);

// EXTERNAL MODULE: external "iviCore"
var external_iviCore_ = __webpack_require__(0);

// CONCATENATED MODULE: ./src/utils.ts

/* istanbul ignore next */
/**
 * getEventTarget retrieves target element from an event.
 *
 * There are still some differences in modern browsers, so we need to use this function to retrieve event targets.
 *
 * #quirks
 *
 * @param ev Event.
 * @returns Target Element.
 */
function getEventTarget(ev) {
    var target = ev.target || window;
    /**
     * Some browsers are implementing it according to SVG 1.1 specs:
     *
     * https://developer.microsoft.com/en-us/microsoft-edge/platform/issues/7998724/
     *
     * "If event attributes are assigned to referenced elements, then the actual target for the event will be the
     * SVGElementInstance object within the 'instance tree' corresponding to the given referenced element."
     *
     * https://www.w3.org/TR/SVG/struct.html#UseElement
     *
     * SVG 2 redefined the use event handling model:
     *
     * - Removed the SVGElementInstance and SVGElementInstanceList interfaces, and the corresponding attributes on the
     *   SVGUseElement interface.
     * - Changed the ‘use’ element event flow to follow the Shadow DOM spec.
     *
     * https://www.w3.org/TR/SVG2/changes.html#structure
     */
    if (target.correspondingUseElement !== undefined) {
        target = target.correspondingUseElement;
    }
    return target;
}
/* istanbul ignore next */
/**
 * `{ capture: true, passive: true }` object that should be used as a 3rd parameter for `addEventListener` method.
 */
var EVENT_CAPTURE_PASSIVE_OPTIONS = external_iviCore_["PASSIVE_EVENTS"] ? { "capture": true, "passive": true } : true;
/* istanbul ignore next */
/**
 * `{ capture: true, passive: false }` object that should be used as a 3rd parameter for `addEventListener` method.
 */
var EVENT_CAPTURE_ACTIVE_OPTIONS = external_iviCore_["PASSIVE_EVENTS"] ? { "capture": true, "passive": false } : true;
/* istanbul ignore next */
/**
 * `{ passive: true }` object that should be used as a 3rd parameter for `addEventListener` method.
 */
var EVENT_PASSIVE_OPTIONS = external_iviCore_["PASSIVE_EVENTS"] ? { "passive": true } : false;
/* istanbul ignore next */
/**
 * `{ passive: false }` object that should be used as a 3rd parameter for `addEventListener` method.
 */
var EVENT_ACTIVE_OPTIONS = external_iviCore_["PASSIVE_EVENTS"] ? { "passive": false } : false;
/* istanbul ignore next */
/**
 * getNativeEventOptions converts `NativeEventSourceFlags` to event options that can be used as a 3rd parameter
 * for `addEventListener` method.
 *
 * #quirks
 *
 * @param flags See `NativeEventSourceFlags` for details.
 * @returns Option object that can be used as a 3rd parameter for `addEventListener` method.
 */
function getNativeEventOptions(flags) {
    if ((flags & 2 /* Passive */) !== 0) {
        if ((flags & 1 /* Capture */) !== 0) {
            return EVENT_CAPTURE_PASSIVE_OPTIONS;
        }
        return EVENT_PASSIVE_OPTIONS;
    }
    if ((flags & 1 /* Capture */) !== 0) {
        return true;
    }
    return false;
}

// CONCATENATED MODULE: ./src/flags.ts
/**
 * NativeEventSourceFlags.
 */
var NativeEventSourceFlags;
(function (NativeEventSourceFlags) {
    /**
     * Capture flag that indicates that events of this type will be dispatched to the registered listener before
     * being dispatched to any EventTarget beneath it in the DOM tree.
     */
    NativeEventSourceFlags[NativeEventSourceFlags["Capture"] = 1] = "Capture";
    /**
     * Passive flag indicating that the listener will never call `preventDefault()`. If it does, the user agent
     * should ignore it.
     */
    NativeEventSourceFlags[NativeEventSourceFlags["Passive"] = 2] = "Passive";
    /**
     * Bubbles flag indicating that the event is bubbling.
     */
    NativeEventSourceFlags[NativeEventSourceFlags["Bubbles"] = 4] = "Bubbles";
})(NativeEventSourceFlags || (NativeEventSourceFlags = {}));
/**
 * EventHandlerFlags.
 */
var EventHandlerFlags;
(function (EventHandlerFlags) {
    /**
     * Capture flag that indicates that events of this type will be dispatched to the registered listener before
     * being dispatched to any EventTarget beneath it in the DOM tree.
     */
    EventHandlerFlags[EventHandlerFlags["Capture"] = 1] = "Capture";
    /**
     * Bubbles flag indicating that the events of this type will be dispatched to the registered listener in the
     * bubbling phase.
     */
    EventHandlerFlags[EventHandlerFlags["Bubble"] = 2] = "Bubble";
    /**
     * Active flag indicates that Event Handler is activated. Available only in Dev Mode.
     */
    EventHandlerFlags[EventHandlerFlags["Active"] = 4] = "Active";
})(EventHandlerFlags || (EventHandlerFlags = {}));
/**
 * SyntheticEventFlags.
 */
var SyntheticEventFlags;
(function (SyntheticEventFlags) {
    /**
     * Default behaviour should be prevented.
     */
    SyntheticEventFlags[SyntheticEventFlags["PreventedDefault"] = 1] = "PreventedDefault";
    /**
     * Propagation is stopped.
     */
    SyntheticEventFlags[SyntheticEventFlags["StoppedPropagation"] = 2] = "StoppedPropagation";
    /**
     * Event can bubble up through the DOM.
     */
    SyntheticEventFlags[SyntheticEventFlags["Bubbles"] = 4] = "Bubbles";
    /**
     * Event is cancelable.
     */
    SyntheticEventFlags[SyntheticEventFlags["Cancelable"] = 8] = "Cancelable";
    /**
     * Event was initiated by the browser.
     */
    SyntheticEventFlags[SyntheticEventFlags["IsTrusted"] = 16] = "IsTrusted";
    /**
     * Event at bubbling phase.
     */
    SyntheticEventFlags[SyntheticEventFlags["BubblePhase"] = 32] = "BubblePhase";
})(SyntheticEventFlags || (SyntheticEventFlags = {}));
var EventFlags;
(function (EventFlags) {
    EventFlags[EventFlags["PreventDefault"] = 1] = "PreventDefault";
    EventFlags[EventFlags["StopPropagation"] = 2] = "StopPropagation";
})(EventFlags || (EventFlags = {}));
/**
 * Prevents default behaviour for an event.
 */
var PREVENT_DEFAULT = 1 /* PreventedDefault */;
/**
 * Stops event propagation.
 */
var STOP_PROPAGATION = 2 /* StoppedPropagation */;

// CONCATENATED MODULE: ./src/traverse_dom.ts
/**
 * accumulateDispatchTargetsFromElement accumulates matching Event Handlers in `result` array from the `target` Element.
 *
 * @param result Accumulated Dispatch Targets.
 * @param target Target Element.
 * @param match Matching function.
 */
function accumulateDispatchTargetsFromElement(result, target, match) {
    var events = target._ev;
    if (events) {
        var handlers = void 0;
        if (Array.isArray(events)) {
            var count = 0;
            for (var _i = 0, events_1 = events; _i < events_1.length; _i++) {
                var h = events_1[_i];
                if (h !== null && match(h) === true) {
                    if (count === 0) {
                        handlers = h;
                    }
                    else if (count === 1) {
                        handlers = [handlers, h];
                    }
                    else {
                        handlers.push(h);
                    }
                    ++count;
                }
            }
        }
        else {
            if (match(events) === true) {
                handlers = events;
            }
        }
        if (handlers !== void 0) {
            result.push({ target: target, handlers: handlers });
        }
    }
}
/**
 * accumulateDispatchTargets traverses the DOM tree from the `target` Element to the document top and accumulates
 * matching Event Handlers in `result` array.
 *
 * @param result Accumulated Dispatch Targets.
 * @param target Target DOM Element.
 * @param match Matching function.
 */
function accumulateDispatchTargets(result, target, match) {
    while (target !== null) {
        accumulateDispatchTargetsFromElement(result, target, match);
        target = target.parentElement;
    }
}

// CONCATENATED MODULE: ./src/dispatch.ts
function _dispatch(handler, dispatch, event) {
    var flags = (dispatch === void 0) ? handler.handler(event) : dispatch(handler, event);
    if (true) {
        if (flags !== void 0) {
            if (flags & ~(1 /* PreventDefault */ | 2 /* StopPropagation */)) {
                throw new Error("Invalid event flags: " + flags);
            }
        }
    }
    return (flags === void 0) ? 0 : flags;
}
/**
 * dispatchEventToLocalEventHandlers dispatches event to local(at the same DOM Node) event handlers.
 *
 * @param target Dispatch Target.
 * @param event Synthetic Event.
 * @param matchFlags Flags that should match to deliver event.
 * @param dispatch Dispatch callback.
 */
function dispatchEventToLocalEventHandlers(target, event, matchFlags, dispatch) {
    var handlers = target.handlers;
    var flags = 0;
    if (Array.isArray(handlers)) {
        for (var _i = 0, handlers_1 = handlers; _i < handlers_1.length; _i++) {
            var handler = handlers_1[_i];
            if (handler.flags & matchFlags) {
                flags |= _dispatch(handler, dispatch, event);
            }
        }
    }
    else if (handlers.flags & matchFlags) {
        flags = _dispatch(handlers, dispatch, event);
    }
    event.flags |= flags;
}
/**
 * dispatchEvent dispatches event to the list of dispatch targets.
 *
 * Simplified version of w3 Events flow algorithm. This algorithm doesn't include target phase, only capture and
 * bubbling phases. We don't care too much about w3 events compatibility, and there aren't any use cases that require
 * target phase.
 *
 * https://www.w3.org/TR/DOM-Level-3-Events/#event-flow
 *
 * @param targets Dispatch targets.
 * @param event Event to dispatch.
 * @param bubble Use bubbling phase.
 * @param dispatch Dispatch callback.
 */
function dispatchEvent(targets, event, bubble, dispatch) {
    var i = targets.length - 1;
    // capture phase
    while (i >= 0) {
        dispatchEventToLocalEventHandlers(targets[i--], event, 1 /* Capture */, dispatch);
        if (event.flags & 2 /* StoppedPropagation */) {
            return;
        }
    }
    // bubble phase
    if (bubble) {
        event.flags |= 32 /* BubblePhase */;
        for (i = 0; i < targets.length; ++i) {
            dispatchEventToLocalEventHandlers(targets[i], event, 2 /* Bubble */, dispatch);
            if (event.flags & 2 /* StoppedPropagation */) {
                return;
            }
        }
    }
}

// CONCATENATED MODULE: /home/void/w/ts/ivi/node_modules/tslib/tslib.es6.js
/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = Object.setPrototypeOf ||
    ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
    function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = Object.assign || function __assign(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
}

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
}

function __decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}

function __param(paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
}

function __metadata(metadataKey, metadataValue) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
}

function __awaiter(thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

function __exportStar(m, exports) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}

function __values(o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
}

function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}

function __spread() {
    for (var ar = [], i = 0; i < arguments.length; i++)
        ar = ar.concat(__read(arguments[i]));
    return ar;
}

function __await(v) {
    return this instanceof __await ? (this.v = v, this) : new __await(v);
}

function __asyncGenerator(thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
    function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
}

function __asyncDelegator(o) {
    var i, p;
    return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
    function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
}

function __asyncValues(o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
}

function __makeTemplateObject(cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};

function __importStar(mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result.default = mod;
    return result;
}

function __importDefault(mod) {
    return (mod && mod.__esModule) ? mod : { default: mod };
}

// CONCATENATED MODULE: ./src/synthetic_event.ts

/**
 * SyntheticEvent is a base class for all synthetic events.
 */
var SyntheticEvent = /** @class */ (function () {
    function SyntheticEvent(flags, timestamp) {
        this.flags = flags;
        this.timestamp = timestamp;
    }
    return SyntheticEvent;
}());

/**
 * SyntheticNativeEvent is a wrapper for native events.
 */
var synthetic_event_SyntheticNativeEvent = /** @class */ (function (_super) {
    __extends(SyntheticNativeEvent, _super);
    function SyntheticNativeEvent(flags, target, timestamp, native) {
        var _this = _super.call(this, flags, timestamp) || this;
        _this.target = target;
        _this.native = native;
        return _this;
    }
    return SyntheticNativeEvent;
}(SyntheticEvent));


// CONCATENATED MODULE: ./src/native_event_source.ts





function createNativeEventSource(flags, name) {
    var source = {
        src: {
            add: function () { ++source.listeners; incDependencies(source); },
            remove: function () { --source.listeners; decDependencies(source); },
        },
        deps: 0,
        listeners: 0,
        flags: flags,
        name: name,
        before: null,
        after: null,
        dispatch: null,
    };
    var matchEventSource = function (h) { return h.src === source.src; };
    source.dispatch = Object(external_iviCore_["catchError"])(function (ev) {
        var targets = [];
        if (source.listeners > 0) {
            accumulateDispatchTargets(targets, getEventTarget(ev), matchEventSource);
        }
        if (targets.length || source.before !== null || source.after !== null) {
            var syntheticEvent = new synthetic_event_SyntheticNativeEvent(0, getEventTarget(ev), ev.timeStamp, ev);
            dispatchToListeners(source.before, syntheticEvent);
            if (targets.length) {
                dispatchEvent(targets, syntheticEvent, (source.flags & 4 /* Bubbles */) !== 0);
            }
            dispatchToListeners(source.after, syntheticEvent);
            if ((syntheticEvent.flags & 1 /* PreventedDefault */) !== 0) {
                ev.preventDefault();
            }
        }
    });
    return source;
}
function addBeforeListener(source, cb) {
    source.before = Object(external_iviCore_["append"])(source.before, cb);
    incDependencies(source);
}
function addAfterListener(source, cb) {
    source.after = Object(external_iviCore_["append"])(source.after, cb);
    incDependencies(source);
}
function removeBeforeListener(source, cb) {
    if (source.before !== null) {
        Object(external_iviCore_["unorderedArrayDelete"])(source.before, source.before.indexOf(cb));
        decDependencies(source);
    }
}
function removeAfterListener(source, cb) {
    if (source.after !== null) {
        Object(external_iviCore_["unorderedArrayDelete"])(source.after, source.after.indexOf(cb));
        decDependencies(source);
    }
}
function incDependencies(source) {
    if (source.deps++ === 0) {
        document.addEventListener(source.name, source.dispatch, getNativeEventOptions(source.flags));
    }
}
function decDependencies(source) {
    if (--source.deps === 0) {
        document.removeEventListener(source.name, source.dispatch, getNativeEventOptions(source.flags));
    }
}
function dispatchToListeners(listeners, ev) {
    if (listeners !== null) {
        var cbs = listeners.slice();
        for (var _i = 0, cbs_1 = cbs; _i < cbs_1.length; _i++) {
            var cb = cbs_1[_i];
            cb(ev);
        }
    }
}

// CONCATENATED MODULE: ./src/sync_events.ts
/**
 * registerEventHandler is a shortcut for Event Handler registration.
 *
 * @param handler Event Handler.
 */
function registerEventHandler(handler) {
    if (true) {
        handler.flags |= 4 /* Active */;
    }
    handler.src.add(handler);
}
/**
 * unregisterEventHandler is a shortcut for Event Handler unregistration.
 *
 * @param handler Event Handler.
 */
function unregisterEventHandler(handler) {
    if (true) {
        handler.flags &= ~4 /* Active */;
    }
    handler.src.remove(handler);
}
/**
 * syncEvents syncs event handlers and invokes EventSource callbacks when event handler is attached or detached.
 *
 * @param a Old event handlers.
 * @param b New event handlers.
 */
function syncEvents(a, b) {
    var i;
    var h1;
    var h2;
    if (a === null) {
        attachEvents(b);
    }
    else if (b === null) {
        detachEvents(a);
    }
    else {
        if (a instanceof Array) {
            if (b instanceof Array) {
                i = 0;
                while (i < a.length && i < b.length) {
                    h1 = a[i];
                    h2 = b[i++];
                    if (h1 !== h2) {
                        if (h2 !== null) {
                            registerEventHandler(h2);
                        }
                        if (h1 !== null) {
                            unregisterEventHandler(h1);
                        }
                    }
                }
                while (i < b.length) {
                    h1 = b[i++];
                    if (h1 !== null) {
                        registerEventHandler(h1);
                    }
                }
                while (i < a.length) {
                    h1 = a[i++];
                    if (h1 !== null) {
                        unregisterEventHandler(h1);
                    }
                }
            }
            else {
                registerEventHandler(b);
                for (i = 0; i < a.length; ++i) {
                    h1 = a[i];
                    if (h1 !== null) {
                        unregisterEventHandler(h1);
                    }
                }
            }
        }
        else {
            attachEvents(b);
            unregisterEventHandler(a);
        }
    }
}
/**
 * attachEvents attaches event handlers and invokes EventSource callbacks.
 *
 * @param events Event handlers.
 */
function attachEvents(events) {
    if (events instanceof Array) {
        for (var i = 0; i < events.length; ++i) {
            var h = events[i];
            if (h !== null) {
                registerEventHandler(h);
            }
        }
    }
    else {
        registerEventHandler(events);
    }
}
/**
 * detachEvents detaches events handles and invokes EventSource callbacks.
 *
 * @param events Event handlers.
 */
function detachEvents(events) {
    if (events instanceof Array) {
        for (var i = 0; i < events.length; ++i) {
            var h = events[i];
            if (h !== null) {
                unregisterEventHandler(h);
            }
        }
    }
    else {
        unregisterEventHandler(events);
    }
}

// CONCATENATED MODULE: ./src/events.ts
/**
 * Event Handlers.
 *
 * Optimizing compilers should inline all this functions and completely remove unused code.
 */

/* tslint:disable:max-line-length */
var EVENT_SOURCE_ABORT = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "abort");
var EVENT_SOURCE_ACTIVATE = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "activate");
var EVENT_SOURCE_ARIA_REQUEST = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "ariarequest");
var EVENT_SOURCE_BEFORE_ACTIVATE = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "beforeactivate");
var EVENT_SOURCE_BEFORE_COPY = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "beforecopy");
var EVENT_SOURCE_BEFORE_CUT = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "beforecut");
var EVENT_SOURCE_BEFORE_DEACTIVATE = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "beforedeactivate");
var EVENT_SOURCE_BEFORE_PASTE = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "beforepaste");
var EVENT_SOURCE_BLUR = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "blur");
var EVENT_SOURCE_CAN_PLAY = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "canplay");
var EVENT_SOURCE_CAN_PLAYTHROUGH = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "canplaythrough");
var EVENT_SOURCE_CHANGE = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "change");
var EVENT_SOURCE_CLICK = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "click");
var EVENT_SOURCE_CONTEXT_MENU = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "contextmenu");
var EVENT_SOURCE_COPY = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "copy");
var EVENT_SOURCE_CUE_CHANGE = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "cuechange");
var EVENT_SOURCE_CUT = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "cut");
var EVENT_SOURCE_DOUBLE_CLICK = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "dblclick");
var EVENT_SOURCE_DEACTIVATE = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "deactivate");
var EVENT_SOURCE_DRAG = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "drag");
var EVENT_SOURCE_DRAG_END = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "dragend");
var EVENT_SOURCE_DRAG_ENTER = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "dragenter");
var EVENT_SOURCE_DRAG_LEAVE = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "dragleave");
var EVENT_SOURCE_DRAG_OVER = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "dragover");
var EVENT_SOURCE_DRAG_START = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "dragstart");
var EVENT_SOURCE_DROP = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "drop");
var EVENT_SOURCE_DURATION_CHANGE = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "durationchange");
var EVENT_SOURCE_EMPTIED = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "emptied");
var EVENT_SOURCE_ENCRYPTED = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "encrypted");
var EVENT_SOURCE_ENDED = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "ended");
var EVENT_SOURCE_ERROR = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "error");
var EVENT_SOURCE_FOCUS = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "focus");
var EVENT_SOURCE_GOT_POINTER_CAPTURE = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "gotpointercapture");
var EVENT_SOURCE_INPUT = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "input");
var EVENT_SOURCE_INVALID = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "invalid");
var EVENT_SOURCE_KEY_DOWN = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "keydown");
var EVENT_SOURCE_KEY_PRESS = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "keypress");
var EVENT_SOURCE_KEY_UP = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "keyup");
var EVENT_SOURCE_LOAD = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "load");
var EVENT_SOURCE_LOADED_DATA = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "loadeddata");
var EVENT_SOURCE_LOADED_METADATA = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "loadedmetadata");
var EVENT_SOURCE_LOAD_START = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "loadstart");
var EVENT_SOURCE_LOST_POINTER_CAPTURE = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "lostpointercapture");
var EVENT_SOURCE_MOUSE_DOWN = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "mousedown");
var EVENT_SOURCE_MOUSE_ENTER = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "mouseenter");
var EVENT_SOURCE_MOUSE_LEAVE = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "mouseleave");
var EVENT_SOURCE_MOUSE_MOVE = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "mousemove");
var EVENT_SOURCE_MOUSE_OUT = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "mouseout");
var EVENT_SOURCE_MOUSE_OVER = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "mouseover");
var EVENT_SOURCE_MOUSE_UP = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "mouseup");
var EVENT_SOURCE_PASTE = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "paste");
var EVENT_SOURCE_PAUSE = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "pause");
var EVENT_SOURCE_PLAY = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "play");
var EVENT_SOURCE_PLAYING = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "playing");
var EVENT_SOURCE_POINTER_CANCEL = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "pointercancel");
var EVENT_SOURCE_POINTER_DOWN = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "pointerdown");
var EVENT_SOURCE_POINTER_ENTER = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "pointerenter");
var EVENT_SOURCE_POINTER_LEAVE = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "pointerleave");
var EVENT_SOURCE_POINTER_MOVE = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "pointermove");
var EVENT_SOURCE_POINTER_OUT = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "pointerout");
var EVENT_SOURCE_POINTER_OVER = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "pointerover");
var EVENT_SOURCE_POINTER_UP = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "pointerup");
var EVENT_SOURCE_PROGRESS = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "progress");
var EVENT_SOURCE_RATE_CHANGE = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "ratechange");
var EVENT_SOURCE_RESET = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "reset");
var EVENT_SOURCE_SCROLL = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "scroll");
var EVENT_SOURCE_SEEKED = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "seeked");
var EVENT_SOURCE_SEEKING = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "seeking");
var EVENT_SOURCE_SELECT = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "select");
var EVENT_SOURCE_SELECT_START = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "selectstart");
var EVENT_SOURCE_STALLED = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "stalled");
var EVENT_SOURCE_SUBMIT = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "submit");
var EVENT_SOURCE_SUSPEND = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "suspend");
var EVENT_SOURCE_TIME_UPDATE = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "timeupdate");
var EVENT_SOURCE_TOUCH_CANCEL = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "touchcancel");
var EVENT_SOURCE_TOUCH_END = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */ | 2 /* Passive */, "touchend");
var EVENT_SOURCE_TOUCH_MOVE = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */ | 2 /* Passive */, "touchmove");
var EVENT_SOURCE_TOUCH_START = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */ | 2 /* Passive */, "touchstart");
var EVENT_SOURCE_UNLOAD = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "unload");
var EVENT_SOURCE_VOLUME_CHANGE = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "volumechange");
var EVENT_SOURCE_WAITING = /*#__PURE__*/ createNativeEventSource(1 /* Capture */, "waiting");
var EVENT_SOURCE_WHEEL = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */ | 2 /* Passive */, "wheel");
var EVENT_SOURCE_ACTIVE_TOUCH_END = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "touchend");
var EVENT_SOURCE_ACTIVE_TOUCH_MOVE = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "touchmove");
var EVENT_SOURCE_ACTIVE_TOUCH_START = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "touchstart");
var EVENT_SOURCE_ACTIVE_WHEEL = /*#__PURE__*/ createNativeEventSource(1 /* Capture */ | 4 /* Bubbles */, "wheel");
/**
 * Helper function that creates event handlers.
 *
 * @param src - Event source
 * @param handler - Event Handler function
 * @param capture - Capture mode
 * @returns EventHandler instance
 */
function createEventHandler(src, handler, capture) {
    return {
        src: src,
        flags: capture === true ? 1 /* Capture */ : 2 /* Bubble */,
        handler: handler,
        listeners: 0,
        props: null,
        state: null,
    };
}
function onAbort(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_ABORT.src, handler, capture);
}
function onActivate(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_ACTIVATE.src, handler, capture);
}
function onAriaRequest(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_ARIA_REQUEST.src, handler, capture);
}
function onBeforeActivate(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_BEFORE_ACTIVATE.src, handler, capture);
}
function onBeforeCopy(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_BEFORE_COPY.src, handler, capture);
}
function onBeforeCut(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_BEFORE_CUT.src, handler, capture);
}
function onBeforeDeactivate(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_BEFORE_DEACTIVATE.src, handler, capture);
}
function onBeforePaste(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_BEFORE_PASTE.src, handler, capture);
}
function onBlur(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_BLUR.src, handler, capture);
}
function onCanPlay(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_CAN_PLAY.src, handler, capture);
}
function onCanPlaythrough(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_CAN_PLAYTHROUGH.src, handler, capture);
}
function onChange(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_CHANGE.src, handler, capture);
}
function onClick(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_CLICK.src, handler, capture);
}
function onContextMenu(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_CONTEXT_MENU.src, handler, capture);
}
function onCopy(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_COPY.src, handler, capture);
}
function onCueChange(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_CUE_CHANGE.src, handler, capture);
}
function onCut(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_CUT.src, handler, capture);
}
function onDoubleClick(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_DOUBLE_CLICK.src, handler, capture);
}
function onDeactivate(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_DEACTIVATE.src, handler, capture);
}
function onDrag(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_DRAG.src, handler, capture);
}
function onDragEnd(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_DRAG_END.src, handler, capture);
}
function onDragEnter(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_DRAG_ENTER.src, handler, capture);
}
function onDragLeave(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_DRAG_LEAVE.src, handler, capture);
}
function onDragOver(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_DRAG_OVER.src, handler, capture);
}
function onDragStart(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_DRAG_START.src, handler, capture);
}
function onDrop(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_DROP.src, handler, capture);
}
function onDurationChange(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_DURATION_CHANGE.src, handler, capture);
}
function onEmptied(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_EMPTIED.src, handler, capture);
}
function onEncrypted(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_ENCRYPTED.src, handler, capture);
}
function onEnded(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_ENDED.src, handler, capture);
}
function onError(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_ERROR.src, handler, capture);
}
function onFocus(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_FOCUS.src, handler, capture);
}
function onGotPointerCapture(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_GOT_POINTER_CAPTURE.src, handler, capture);
}
function onInput(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_INPUT.src, handler, capture);
}
function onInvalid(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_INVALID.src, handler, capture);
}
function onKeyDown(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_KEY_DOWN.src, handler, capture);
}
function onKeyPress(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_KEY_PRESS.src, handler, capture);
}
function onKeyUp(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_KEY_UP.src, handler, capture);
}
function onLoad(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_LOAD.src, handler, capture);
}
function onLoadedData(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_LOADED_DATA.src, handler, capture);
}
function onLoadedMetadata(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_LOADED_METADATA.src, handler, capture);
}
function onLoadStart(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_LOAD_START.src, handler, capture);
}
function onLostPointerCapture(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_LOST_POINTER_CAPTURE.src, handler, capture);
}
function onMouseDown(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_MOUSE_DOWN.src, handler, capture);
}
function onMouseEnter(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_MOUSE_ENTER.src, handler, capture);
}
function onMouseLeave(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_MOUSE_LEAVE.src, handler, capture);
}
function onMouseMove(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_MOUSE_MOVE.src, handler, capture);
}
function onMouseOut(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_MOUSE_OUT.src, handler, capture);
}
function onMouseOver(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_MOUSE_OVER.src, handler, capture);
}
function onMouseUp(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_MOUSE_UP.src, handler, capture);
}
function onPaste(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_PASTE.src, handler, capture);
}
function onPause(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_PAUSE.src, handler, capture);
}
function onPlay(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_PLAY.src, handler, capture);
}
function onPlaying(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_PLAYING.src, handler, capture);
}
function onPointerCancel(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_POINTER_CANCEL.src, handler, capture);
}
function onPointerDown(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_POINTER_DOWN.src, handler, capture);
}
function onPointerEnter(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_POINTER_ENTER.src, handler, capture);
}
function onPointerLeave(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_POINTER_LEAVE.src, handler, capture);
}
function onPointerMove(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_POINTER_MOVE.src, handler, capture);
}
function onPointerOut(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_POINTER_OUT.src, handler, capture);
}
function onPointerOver(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_POINTER_OVER.src, handler, capture);
}
function onPointerUp(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_POINTER_UP.src, handler, capture);
}
function onProgress(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_PROGRESS.src, handler, capture);
}
function onRateChange(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_RATE_CHANGE.src, handler, capture);
}
function onReset(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_RESET.src, handler, capture);
}
function onScroll(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_SCROLL.src, handler, capture);
}
function onSeeked(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_SEEKED.src, handler, capture);
}
function onSeeking(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_SEEKING.src, handler, capture);
}
function onSelect(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_SELECT.src, handler, capture);
}
function onSelectStart(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_SELECT_START.src, handler, capture);
}
function onStalled(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_STALLED.src, handler, capture);
}
function onSubmit(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_SUBMIT.src, handler, capture);
}
function onSuspend(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_SUSPEND.src, handler, capture);
}
function onTimeUpdate(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_TIME_UPDATE.src, handler, capture);
}
function onTouchCancel(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_TOUCH_CANCEL.src, handler, capture);
}
function onTouchEnd(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_TOUCH_END.src, handler, capture);
}
function onTouchMove(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_TOUCH_MOVE.src, handler, capture);
}
function onTouchStart(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_TOUCH_START.src, handler, capture);
}
function onUnload(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_UNLOAD.src, handler, capture);
}
function onVolumeChange(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_VOLUME_CHANGE.src, handler, capture);
}
function onWaiting(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_WAITING.src, handler, capture);
}
function onWheel(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_WHEEL.src, handler, capture);
}
function onActiveTouchEnd(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_ACTIVE_TOUCH_END.src, handler, capture);
}
function onActiveTouchMove(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_ACTIVE_TOUCH_MOVE.src, handler, capture);
}
function onActiveTouchStart(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_ACTIVE_TOUCH_START.src, handler, capture);
}
function onActiveWheel(handler, capture) {
    if (capture === void 0) { capture = false; }
    return createEventHandler(EVENT_SOURCE_ACTIVE_WHEEL.src, handler, capture);
}
/* tslint:enable:max-line-length */

// CONCATENATED MODULE: ./src/index.ts
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "getEventTarget", function() { return getEventTarget; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "getNativeEventOptions", function() { return getNativeEventOptions; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_CAPTURE_PASSIVE_OPTIONS", function() { return EVENT_CAPTURE_PASSIVE_OPTIONS; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_CAPTURE_ACTIVE_OPTIONS", function() { return EVENT_CAPTURE_ACTIVE_OPTIONS; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_PASSIVE_OPTIONS", function() { return EVENT_PASSIVE_OPTIONS; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_ACTIVE_OPTIONS", function() { return EVENT_ACTIVE_OPTIONS; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "NativeEventSourceFlags", function() { return NativeEventSourceFlags; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EventHandlerFlags", function() { return EventHandlerFlags; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "SyntheticEventFlags", function() { return SyntheticEventFlags; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EventFlags", function() { return EventFlags; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "PREVENT_DEFAULT", function() { return PREVENT_DEFAULT; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "STOP_PROPAGATION", function() { return STOP_PROPAGATION; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "accumulateDispatchTargets", function() { return accumulateDispatchTargets; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "accumulateDispatchTargetsFromElement", function() { return accumulateDispatchTargetsFromElement; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "dispatchEvent", function() { return dispatchEvent; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "SyntheticEvent", function() { return SyntheticEvent; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "SyntheticNativeEvent", function() { return synthetic_event_SyntheticNativeEvent; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "createNativeEventSource", function() { return createNativeEventSource; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "addBeforeListener", function() { return addBeforeListener; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "addAfterListener", function() { return addAfterListener; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "removeBeforeListener", function() { return removeBeforeListener; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "removeAfterListener", function() { return removeAfterListener; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "syncEvents", function() { return syncEvents; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "attachEvents", function() { return attachEvents; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "detachEvents", function() { return detachEvents; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_ABORT", function() { return EVENT_SOURCE_ABORT; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_ACTIVATE", function() { return EVENT_SOURCE_ACTIVATE; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_ARIA_REQUEST", function() { return EVENT_SOURCE_ARIA_REQUEST; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_BEFORE_ACTIVATE", function() { return EVENT_SOURCE_BEFORE_ACTIVATE; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_BEFORE_COPY", function() { return EVENT_SOURCE_BEFORE_COPY; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_BEFORE_CUT", function() { return EVENT_SOURCE_BEFORE_CUT; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_BEFORE_DEACTIVATE", function() { return EVENT_SOURCE_BEFORE_DEACTIVATE; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_BEFORE_PASTE", function() { return EVENT_SOURCE_BEFORE_PASTE; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_BLUR", function() { return EVENT_SOURCE_BLUR; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_CAN_PLAY", function() { return EVENT_SOURCE_CAN_PLAY; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_CAN_PLAYTHROUGH", function() { return EVENT_SOURCE_CAN_PLAYTHROUGH; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_CHANGE", function() { return EVENT_SOURCE_CHANGE; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_CLICK", function() { return EVENT_SOURCE_CLICK; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_CONTEXT_MENU", function() { return EVENT_SOURCE_CONTEXT_MENU; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_COPY", function() { return EVENT_SOURCE_COPY; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_CUE_CHANGE", function() { return EVENT_SOURCE_CUE_CHANGE; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_CUT", function() { return EVENT_SOURCE_CUT; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_DOUBLE_CLICK", function() { return EVENT_SOURCE_DOUBLE_CLICK; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_DEACTIVATE", function() { return EVENT_SOURCE_DEACTIVATE; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_DRAG", function() { return EVENT_SOURCE_DRAG; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_DRAG_END", function() { return EVENT_SOURCE_DRAG_END; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_DRAG_ENTER", function() { return EVENT_SOURCE_DRAG_ENTER; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_DRAG_LEAVE", function() { return EVENT_SOURCE_DRAG_LEAVE; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_DRAG_OVER", function() { return EVENT_SOURCE_DRAG_OVER; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_DRAG_START", function() { return EVENT_SOURCE_DRAG_START; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_DROP", function() { return EVENT_SOURCE_DROP; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_DURATION_CHANGE", function() { return EVENT_SOURCE_DURATION_CHANGE; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_EMPTIED", function() { return EVENT_SOURCE_EMPTIED; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_ENCRYPTED", function() { return EVENT_SOURCE_ENCRYPTED; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_ENDED", function() { return EVENT_SOURCE_ENDED; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_ERROR", function() { return EVENT_SOURCE_ERROR; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_FOCUS", function() { return EVENT_SOURCE_FOCUS; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_GOT_POINTER_CAPTURE", function() { return EVENT_SOURCE_GOT_POINTER_CAPTURE; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_INPUT", function() { return EVENT_SOURCE_INPUT; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_INVALID", function() { return EVENT_SOURCE_INVALID; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_KEY_DOWN", function() { return EVENT_SOURCE_KEY_DOWN; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_KEY_PRESS", function() { return EVENT_SOURCE_KEY_PRESS; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_KEY_UP", function() { return EVENT_SOURCE_KEY_UP; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_LOAD", function() { return EVENT_SOURCE_LOAD; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_LOADED_DATA", function() { return EVENT_SOURCE_LOADED_DATA; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_LOADED_METADATA", function() { return EVENT_SOURCE_LOADED_METADATA; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_LOAD_START", function() { return EVENT_SOURCE_LOAD_START; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_LOST_POINTER_CAPTURE", function() { return EVENT_SOURCE_LOST_POINTER_CAPTURE; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_MOUSE_DOWN", function() { return EVENT_SOURCE_MOUSE_DOWN; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_MOUSE_ENTER", function() { return EVENT_SOURCE_MOUSE_ENTER; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_MOUSE_LEAVE", function() { return EVENT_SOURCE_MOUSE_LEAVE; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_MOUSE_MOVE", function() { return EVENT_SOURCE_MOUSE_MOVE; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_MOUSE_OUT", function() { return EVENT_SOURCE_MOUSE_OUT; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_MOUSE_OVER", function() { return EVENT_SOURCE_MOUSE_OVER; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_MOUSE_UP", function() { return EVENT_SOURCE_MOUSE_UP; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_PASTE", function() { return EVENT_SOURCE_PASTE; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_PAUSE", function() { return EVENT_SOURCE_PAUSE; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_PLAY", function() { return EVENT_SOURCE_PLAY; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_PLAYING", function() { return EVENT_SOURCE_PLAYING; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_POINTER_CANCEL", function() { return EVENT_SOURCE_POINTER_CANCEL; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_POINTER_DOWN", function() { return EVENT_SOURCE_POINTER_DOWN; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_POINTER_ENTER", function() { return EVENT_SOURCE_POINTER_ENTER; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_POINTER_LEAVE", function() { return EVENT_SOURCE_POINTER_LEAVE; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_POINTER_MOVE", function() { return EVENT_SOURCE_POINTER_MOVE; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_POINTER_OUT", function() { return EVENT_SOURCE_POINTER_OUT; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_POINTER_OVER", function() { return EVENT_SOURCE_POINTER_OVER; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_POINTER_UP", function() { return EVENT_SOURCE_POINTER_UP; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_PROGRESS", function() { return EVENT_SOURCE_PROGRESS; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_RATE_CHANGE", function() { return EVENT_SOURCE_RATE_CHANGE; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_RESET", function() { return EVENT_SOURCE_RESET; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_SCROLL", function() { return EVENT_SOURCE_SCROLL; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_SEEKED", function() { return EVENT_SOURCE_SEEKED; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_SEEKING", function() { return EVENT_SOURCE_SEEKING; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_SELECT", function() { return EVENT_SOURCE_SELECT; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_SELECT_START", function() { return EVENT_SOURCE_SELECT_START; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_STALLED", function() { return EVENT_SOURCE_STALLED; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_SUBMIT", function() { return EVENT_SOURCE_SUBMIT; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_SUSPEND", function() { return EVENT_SOURCE_SUSPEND; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_TIME_UPDATE", function() { return EVENT_SOURCE_TIME_UPDATE; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_TOUCH_CANCEL", function() { return EVENT_SOURCE_TOUCH_CANCEL; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_TOUCH_END", function() { return EVENT_SOURCE_TOUCH_END; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_TOUCH_MOVE", function() { return EVENT_SOURCE_TOUCH_MOVE; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_TOUCH_START", function() { return EVENT_SOURCE_TOUCH_START; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_UNLOAD", function() { return EVENT_SOURCE_UNLOAD; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_VOLUME_CHANGE", function() { return EVENT_SOURCE_VOLUME_CHANGE; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_WAITING", function() { return EVENT_SOURCE_WAITING; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_WHEEL", function() { return EVENT_SOURCE_WHEEL; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_ACTIVE_TOUCH_END", function() { return EVENT_SOURCE_ACTIVE_TOUCH_END; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_ACTIVE_TOUCH_MOVE", function() { return EVENT_SOURCE_ACTIVE_TOUCH_MOVE; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_ACTIVE_TOUCH_START", function() { return EVENT_SOURCE_ACTIVE_TOUCH_START; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "EVENT_SOURCE_ACTIVE_WHEEL", function() { return EVENT_SOURCE_ACTIVE_WHEEL; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "createEventHandler", function() { return createEventHandler; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onAbort", function() { return onAbort; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onActivate", function() { return onActivate; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onAriaRequest", function() { return onAriaRequest; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onBeforeActivate", function() { return onBeforeActivate; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onBeforeCopy", function() { return onBeforeCopy; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onBeforeCut", function() { return onBeforeCut; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onBeforeDeactivate", function() { return onBeforeDeactivate; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onBeforePaste", function() { return onBeforePaste; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onBlur", function() { return onBlur; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onCanPlay", function() { return onCanPlay; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onCanPlaythrough", function() { return onCanPlaythrough; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onChange", function() { return onChange; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onClick", function() { return onClick; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onContextMenu", function() { return onContextMenu; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onCopy", function() { return onCopy; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onCueChange", function() { return onCueChange; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onCut", function() { return onCut; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onDoubleClick", function() { return onDoubleClick; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onDeactivate", function() { return onDeactivate; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onDrag", function() { return onDrag; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onDragEnd", function() { return onDragEnd; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onDragEnter", function() { return onDragEnter; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onDragLeave", function() { return onDragLeave; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onDragOver", function() { return onDragOver; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onDragStart", function() { return onDragStart; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onDrop", function() { return onDrop; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onDurationChange", function() { return onDurationChange; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onEmptied", function() { return onEmptied; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onEncrypted", function() { return onEncrypted; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onEnded", function() { return onEnded; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onError", function() { return onError; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onFocus", function() { return onFocus; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onGotPointerCapture", function() { return onGotPointerCapture; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onInput", function() { return onInput; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onInvalid", function() { return onInvalid; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onKeyDown", function() { return onKeyDown; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onKeyPress", function() { return onKeyPress; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onKeyUp", function() { return onKeyUp; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onLoad", function() { return onLoad; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onLoadedData", function() { return onLoadedData; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onLoadedMetadata", function() { return onLoadedMetadata; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onLoadStart", function() { return onLoadStart; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onLostPointerCapture", function() { return onLostPointerCapture; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onMouseDown", function() { return onMouseDown; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onMouseEnter", function() { return onMouseEnter; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onMouseLeave", function() { return onMouseLeave; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onMouseMove", function() { return onMouseMove; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onMouseOut", function() { return onMouseOut; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onMouseOver", function() { return onMouseOver; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onMouseUp", function() { return onMouseUp; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onPaste", function() { return onPaste; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onPause", function() { return onPause; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onPlay", function() { return onPlay; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onPlaying", function() { return onPlaying; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onPointerCancel", function() { return onPointerCancel; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onPointerDown", function() { return onPointerDown; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onPointerEnter", function() { return onPointerEnter; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onPointerLeave", function() { return onPointerLeave; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onPointerMove", function() { return onPointerMove; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onPointerOut", function() { return onPointerOut; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onPointerOver", function() { return onPointerOver; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onPointerUp", function() { return onPointerUp; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onProgress", function() { return onProgress; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onRateChange", function() { return onRateChange; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onReset", function() { return onReset; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onScroll", function() { return onScroll; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onSeeked", function() { return onSeeked; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onSeeking", function() { return onSeeking; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onSelect", function() { return onSelect; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onSelectStart", function() { return onSelectStart; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onStalled", function() { return onStalled; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onSubmit", function() { return onSubmit; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onSuspend", function() { return onSuspend; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onTimeUpdate", function() { return onTimeUpdate; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onTouchCancel", function() { return onTouchCancel; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onTouchEnd", function() { return onTouchEnd; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onTouchMove", function() { return onTouchMove; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onTouchStart", function() { return onTouchStart; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onUnload", function() { return onUnload; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onVolumeChange", function() { return onVolumeChange; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onWaiting", function() { return onWaiting; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onWheel", function() { return onWheel; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onActiveTouchEnd", function() { return onActiveTouchEnd; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onActiveTouchMove", function() { return onActiveTouchMove; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onActiveTouchStart", function() { return onActiveTouchStart; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "onActiveWheel", function() { return onActiveWheel; });










/***/ })
/******/ ]);
});
//# sourceMappingURL=ivi-events.js.map